{{ $sha := sha256 (.Get 0) }}
{{ $id := substr $sha 0 10 }}
<div class="check_flag">
    <h2 class="check_flag-title">Vérification du flag</h2>
    <form onsubmit="return false">
      <div class="check_flag-input_container">
        <p hidden class="check_flag-message check_flag-message--success" id="success-{{- $id -}}">
            Bien joué ! Tu as trouvé le bon flag !
        </p>
        <p hidden class="check_flag-message check_flag-message--failure" id="failure-{{- $id -}}">
            Dommage, ce n'est pas le bon flag...
        </p>
        <input
            class="check_flag-input"
            type="text"
            placeholder="Ton flag"
            id="flag-{{- $id -}}"
        />
      </div>
      <button
          class="check_flag-button"
          id="button-{{- $id -}}"
      >
<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--!Font Awesome Free 6.7.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M438.6 278.6c12.5-12.5 12.5-32.8 0-45.3l-160-160c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3L338.8 224 32 224c-17.7 0-32 14.3-32 32s14.3 32 32 32l306.7 0L233.4 393.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0l160-160z"/></svg>
      </button>
    </form>

    <script>
        // This is weird because the function is unique to each shortcode,
        // but we can't use $id in the function name due to Hugo restrictions
        (() => {
            const checker = async () => {
                const flagHash = "{{- $sha -}}";

                // Get the input string
                const inputField = document.getElementById('flag-{{- $id -}}');
                const input = inputField.value;

                // Convert the input string to a Uint8Array
                const textBuffer = new TextEncoder().encode(input);

                // Compute the hash (SHA-256 in this case)
                const hashBuffer = await crypto.subtle.digest('SHA-256', textBuffer);

                // Convert the hash buffer to a hexadecimal string
                const hashArray = Array.from(new Uint8Array(hashBuffer));
                const hashHex = hashArray.map(b => b.toString(16).padStart(2, '0')).join('');

                const paragraphSuccess = document.getElementById('success-{{- $id -}}')
                const paragraphFailure = document.getElementById('failure-{{- $id -}}')

                paragraphSuccess.hidden = !(flagHash === hashHex);
                paragraphFailure.hidden = (flagHash === hashHex);

                if (flagHash === hashHex) {
                    inputField.classList.add("check_flag-input--valid");
                    inputField.readOnly = true;
                }

                setTimeout(() => {
                    paragraphSuccess.hidden = true;
                    paragraphFailure.hidden = true;
                }, 1500);
            }

            const button = document.getElementById('button-{{- $id -}}')
            button.addEventListener('click', checker)
        })()
    </script>
</div>
